hdu4883/BestCoder#2_1001

题意:(模拟)

在一个餐厅里每天会有好几波客人,给出他们来的时间和走的时间,

询问餐厅最少需要多少把椅子才能使来的客人都有椅子坐。

正确思路:

客人来的时候餐厅总人数增加(v),客人走的时候餐厅总人数增加(-v),v代表每一波来的人数

开辟一个2*n的数组(node类型),node.t保存来的时刻或走的时刻,node.v保存应该增加的人数,

对于 “来“ 的时刻node.v=v,对于“走“的时刻node.v=-v;对数组进行排序(按照时间的先后顺序),注意:对于测试

案例发现临界情况所以排序时,将同一时刻的 “离开“ 放在 “来“ 的前面

#include <cstdio>
#include <cstring>
#include <algorithm>
#define MAX 20010
using namespace std;
struct node{
    int t;
    int v;
}d[MAX];
bool cmp(node a,node b){
    if(a.t==b.t) return a.v<b.v;
    return a.t<b.t;
}
int main(){
    int T;
    scanf("%d",&T);
    int n;
    while(T--){
        scanf("%d",&n);
        memset(d,0,sizeof(d));
         int sh,sm,th,tm,v;
        for(int i=0;i<n;++i){
            scanf("%d%d:%d%d:%d",&v,&sh,&sm,&th,&tm);
            d[i*2].t=sh*60+sm;
            d[i*2].v=v;
            d[i*2+1].t=th*60+tm;
            d[i*2+1].v=-v;
        }
        sort(d,d+2*n,cmp);
        int ans=0;
        int s=0;
        for(int i=0;i<2*n;++i){
            s+=d[i].v;
            if(s>ans)
                ans=s;
        }
        printf("%d\n",ans);
    }
    return 0;
}

错误思路:

刚开始打算对于时间段进行排序,但经过分析发现对于开始时间或结束时间排序都无法解决这道题(收获:学会切分的思想);

然后又思考区间重叠,还是无法解决,最终暴力解决,枚举0-24,对于每个时间段:1440*10000.显然超时

附上超时代码:

#include <cstdio>
#include <cstring>
#define MAX 10010
using namespace std;
struct node{
    int cn;
    int sth;
    int stm;
    int eth;
    int etm;
    int st;
    int et;
}e[MAX];
int ans[24][60];
int n;
int main()
{
    int T;
    scanf("%d",&T);
    while(T--){
        scanf("%d",&n);
        for(int i=0;i<n;++i){
            scanf("%d%d:%d%d:%d",&e[i].cn,&e[i].sth,&e[i].stm,&e[i].eth,&e[i].etm);
            e[i].st=e[i].sth*60+e[i].stm;
            e[i].et=e[i].eth*60+e[i].etm;
        }
        memset(ans,0,sizeof(ans));
        for(int i=0;i<24;++i){
            for(int j=0;j<60;++j){
                for(int k=0;k<n;++k){
                    int tmp=i*60+j;
                    if(tmp>=e[k].st&&tmp<e[k].et)
                        ans[i][j]+=e[k].cn;
                }
            }
        }
        int bestans=0;
        for(int i=0;i<24;++i)
            for(int j=0;j<60;++j)
                if(ans[i][j]>bestans)
                    bestans=ans[i][j];
        printf("%d\n",bestans);
    }
    return 0;
}

收获:1、模型变换(切分思想)

2、超时体验

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-11-07 20:36:57

hdu4883/BestCoder#2_1001的相关文章

BestCoder Round #91

传送门:http://acm.hdu.edu.cn/search.php?field=problem&key=BestCoder+Round+%2391&source=1&searchmode=source A题:给你n种字母,每种字母有个权值vali,共cnti个,现在让你在里面挑出任意数量的字符,组合成一个字符串,该字符串的权值的计算方式为val1*1+val2*2+--+valn*n,让你输出字符串最大的权值是多少.这题很容易会有一个错误的贪心,就是把val为负的舍去,然后v

7-16 Bestcoder a Oracle

Time Limit: 8000/4000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)Total Submission(s): 325    Accepted Submission(s): 139 Problem Description There is once a king and queen, rulers of an unnamed city, who have three daughters of co

HDU 5682/BestCoder Round #83 1003 zxa and leaf 二分+树

zxa and leaf Problem Description zxa have an unrooted tree with n nodes, including (n−1) undirected edges, whose nodes are numbered from 1 to n. The degree of each node is defined as the number of the edges connected to it, and each node whose degree

BestCoder Round #65 (ZYB&#39;s Game)

ZYB's Game Accepts: 672 Submissions: 1207 Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others) Problem Description ZYBZYBZYB played a game named NumberBombNumber BombNumberBomb with his classmates in hiking:a host keeps a

BestCoder 1st Anniversary

problem 1001 Souvenir Accepts: 901 Submissions: 2743 Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 262144/262144 K (Java/Others) 问题描述 今天是BestCoder一周年纪念日. 比赛管理员Soda想要给每个参赛者准备一个纪念品. 商店里纪念品的单价是p元, 同时也可以花q元购买纪念品套装, 一个套装里有mm个纪念品. 今天总共有nn个参赛者, Soda想

hdu5418 BestCoder Round #52 (div.2) Victor and World ( floyd+状压dp)

Problem Description After trying hard for many years, Victor has finally received a pilot license. To have a celebration, he intends to buy himself an airplane and fly around the world. There are n countries on the earth, which are numbered from 1 to

【BestCoder】【Round#42】

模拟+链表+DP Orz AK爷faebdc A Growin要跟全部的n个人握手共2n杯香槟,再加上每对关系的两杯香槟,直接统计邻接矩阵中1的个数,再加2n就是answer 1 //BestCoder 42 A 2 #include<vector> 3 #include<cstdio> 4 #include<cstring> 5 #include<cstdlib> 6 #include<iostream> 7 #include<algor

bestcoder#37_1001 字符串,贪心

bestcoder#37_1001 字符串,dfs Rikka with string Accepts: 395 Submissions: 2281 Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others) Problem Description As we know, Rikka is poor at math. Yuta is worrying about this situation,

【BestCoder】#29 C GTY&#39;s gay friends(区间和 随机数判重)

题目大意:可以到相应的场次查看中文翻译. 思路:其实这道题很简单,对于一个等差数列,我们要判断他是否每个数都出现,只需要判断区间和或者是最大值是否符合即可,但这边需要注意的便是中间的重复部分.最大值的判重必要性我就不知道了,而且我也不会做,目测做也超时. 这边就写一下偷别人的区间和+随机数判重的做法 其实这边判重的方法是给一个数加上一个超过1000007的权,然后在计算和的时候,便是唯一的. 否则例如下面的情况 10 11的和可以由5和16构成,既然两个的和可以被另外一个的两个数替代,那我们就找